<?php

//this is display_spotless_days.php

//include the functions file
require_once('sunspot_data_functions.php');


//set some vars
$year = 2008;

//create an array we'll temporarily store results in
$results_array = array();


//simply loop and call our function
//to get the number of spotless days per month
//the earliest year is 1818
while($year > 1817){

	//note this loop starts at 12 and goes down
	for($i=12; $i>0; $i--){
	
		//get the number of spotless days in this month
		$spotless_days = getNumSpotlessDays($i, $year);

		//get a timestamp for this date
		pad($i);
		$date_string = "$i/01/$year";
		$timestamp = strtotime($date_string);
		//echo "timestamp is $timestamp <br>";

		//get the month abbreviation
		$month_abbrev = date('M', $timestamp);
		
		//join the values with a pipe
		//so we can add them to our array and easily split them later
		array_push($results_array, "$month_abbrev $year:|$spotless_days");
	}


	//decrement the year
	$year--;
}


//we loop through the results below

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Untitled Document</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="sunspot_test_styles.css" rel="stylesheet" type="text/css">
</head>

<body>
<table width="400" border="1" cellpadding="0" cellspacing="0" bordercolor="#999999">
  <?php

//loop through the array we generated above
//and display a table row for each result
foreach($results_array as $my_var){

	//split on the pipe
	$exploded_pipe_array = explode('|', $my_var);

	//display the array elements in a table row
	echo "<tr>
    <td width='164' class='monthStringText'>$exploded_pipe_array[0]</td>
    <td width='222' class='spotlessDaysText'>$exploded_pipe_array[1]</td>
  </tr>";
}

?>
	<!--
  <tr> 
    <td width='164' class='monthStringText'>$exploded_pipe_array[0]</td>
    <td width='222' class='spotlessDaysText'>$exploded_pipe_array[1]</td>
  </tr>
  -->
</table>
</body>
</html>
