<?php

//this is display_spotless_spans.php

//include the functions file
require_once('sunspot_data_functions.php');


//////////////////////////////////
//function to validate a submitted year
function validateYearSpan($year){

	//make sure it's a multiple of 100
	
	//make sure it's a positive number
	if($year < 0){
		return false;
	}
	
	//if we got here we can return true
	return true;
}
//////////////////////////////////


//////////////////////////////////
//////////////////////////////////
//set some default values
if(!$_GET['year_span']){
	$year_span = 100;
}

if(!$_GET['sort_by']){
	$sort_by = 'year';
}
//////////////////////////////////
//////////////////////////////////

//validate the year
if(!validateYearSpan($year_span)){
	$error_message = 'Error: this page requires a valid year span.';
	errorHandler($error_message);
}



//set some vars
$year = 2008;

//get the starting year by subtracting our year_span from it
$start_year = ($year - $year_span);

//use our function to get the last date in the database
$last_month = getLastRecordMonth();

//call our function select all the records from this 
//date span into an assoc array of IDs and SunspotNumbers
$ids_spots_assoc = getIDsSpotsAssoc(1, $start_year, $last_month, $year);

//call our function to return the top five continuous
//dates with SunspotNumber of zero in an array
$results_assoc = returnContinuousSpotsAssoc($ids_spots_assoc);



//if they wanted to sort by spotless days
//then we need to sort the array
if($sort_by == 'spotless_days'){
	arsort($results_assoc);
}


else{
	$results_assoc = array_reverse($results_assoc, true);
}

//we loop through the results below

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Untitled Document</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="sunspot_test_styles.css" rel="stylesheet" type="text/css">
</head>

<body>
<?php
			
			//if there was an error message then display it
			if($error_message){
			
				echo "<span class='errorMessageText'>$error_message</span> 
              <table width='100%' border='0' cellspacing='0' cellpadding='0'>
                <tr> 
                  <td><img src='images/spacer.gif' width='10' height='9'></td>
                </tr>
              </table>";
			}
			
			?>
<?php
			
			//if there was an admin message then display it
			if($admin_message){
			
				echo "<span class='errorMessageText'>$admin_message</span> 
              <table width='100%' border='0' cellspacing='0' cellpadding='0'>
                <tr> 
                  <td><img src='images/spacer.gif' width='10' height='9'></td>
                </tr>
              </table>";
			}
			
			?>
<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="84%"><form action="<?php echo $PHP_SELF; ?>" name="form1">
        <span class="nowShowingText">Showing:</span> 
        <select name="year_span">
          <?php
		  
		  	//display options for between 100 and 500
			for($i=100; $i<300; $i+=100){
			
				//if this iteration is the same as
				//the year span we received via GET
				//then show that value as the selected
				if($i == $year_span){
					echo "<option value='$i' selected>Last $i years</option>";
				}
				
				//else just show it as a normal option
				else{
					echo "<option value='$i'>Last $i years</option>";
				}
			}
		  
		  	
		  ?>
        </select>
        <span class="nowShowingText">Sort by:</span> 
        <select name="sort_by" id="sort_by">
          <option value="year">year</option>
          <option value="spotless_days">spotless days</option>
        </select>
        <input name="go" type="submit" id="go" value="go">
      </form></td>
  </tr>
</table>
<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td><img src="images/spacer.gif" width="10" height="10"></td>
  </tr>
</table>
<table width="400" border="1" cellpadding="0" cellspacing="0" bordercolor="#999999">
  <?php

//loop through the array we generated above
//and display a table row for each result
foreach($results_assoc as $my_key => $my_val){

	$my_date = getDateFromRecordID($my_key);

	//display the values in a table row
	echo "<tr>
    <td width='164' class='monthStringText'>$my_date</td>
    <td width='222' class='spotlessDaysText'>$my_val</td>
  </tr>";
}

?>
	<!--
  <tr> 
    <td width='164' class='monthStringText'>$exploded_pipe_array[0]</td>
    <td width='222' class='spotlessDaysText'>$exploded_pipe_array[1]</td>
  </tr>
  -->
</table>
<p class="headerText">&nbsp;</p>
</body>
</html>
