<?php

//this is generate_spotless_chart.php
//by joshua kitchener <staff@dot-comet.com>
//THERE CAN BE NO OUTPUTTING IN THIS SCRIPT!!
//IT WILL CAUSE THE SCRIPT TO FAIL SILENTLY

//include the functions file
require_once('sunspot_data_functions.php');

//include charts.php to access the SendChartData function
require_once('charts.php');


//the function to convert the chart's data so that 
//both series have the same scale from 0 to 100
//from http://www.maani.us/charts/index.php?menu=Reference&submenu=axis_value_text
function asPercentage ( $value, $min, $max ){
   return ($value-$min)*100/($max-$min);
}



//use our functions to generate to default dates
$start_date_assoc = getValidStartDate();
$end_date_assoc = getLastRecordDate();

/*
/////////////////////////////////////////////
//we'll set some defaults in case no values were sent
if(!$start_month){
	$start_date_assoc['Month'];
}

if(!$end_month){
	$end_date_assoc['Month'];
}


if(!$start_year){
	$start_date_assoc['Year'];
}

if(!$end_year){
	$end_date_assoc['Year'];
}

//we'll show both datums by default
if(!$view_sunspotnumbers_checkbox){ $view_sunspotnumbers_checkbox = 'yes'; }
if(!$view_spotlessdays_checkbox){ $view_spotlessdays_checkbox = 'yes'; }
/////////////////////////////////////////////
*/

//this null element is critical to the flash chart
$chart['chart_data'][0][0] = "";

//call our function to return an array
//of all month/years in the span
$month_years_array = getMonthYearsArray($start_month, $start_year, $end_month, $end_year);

//get the size of the array
$my_count = count($month_years_array);

//we'll just assign the count minus one
//to a convenient reference var so we can use it later
$count_minus_one = ($my_count - 1);

//we want to display a date on every 1/10th value on the axis
//so we'll divide our total number of results by ten
$my_divisor = ($my_count / 10);
//round it off
$my_divisor = round($my_divisor);


////////////////////////////////////////////
//if they sent a command to view only sunspot numbers
if($view_sunspotnumbers_checkbox == 'yes' && $view_spotlessdays_checkbox != 'yes'){

	//here's the titles of the chart
	$chart['chart_data'][1][0] = 'Sunspot number';
	
	//loop through the array and add all the elements to the chart
	for($i=0; $i<$my_count; $i++){
	
		//we have to add one to the index since our
		//zero index is the title of the chart
		$my_index = ($i + 1);

		//get a modulus so we can display every tenth tick on the axis
		$my_modulo = ($i % $my_divisor);
	
		//if this is the first or last result or a multiple of ten
		//then add this month and year to the axis
		//otherwise all the years will crowd up and become a mess
		//ACTUALLY WE'LL SHOW 11 DATE TICKS
		//10 IS MUCH HARDER TO CALCULATE SINCE ZERO ELEMENT 
		//ALSO RESULTS IN A MODULUS OF ZERO
		if(($my_modulo == 0 || $i == 0 || $i == $count_minus_one) && $month_years_array[$i] > 0){
			$chart['chart_data'][0][$my_index] = $month_years_array[$i];
		}
	
		//else just use an empty string
		else{
			$chart['chart_data'][0][$my_index] = '';
		}
		
		//add the number of spotless days using our function
		//first we have to split the month and year on the leading slash
		$exploded_slash_array = explode('/', $month_years_array[$i]);
		$my_month = $exploded_slash_array[0];
		$my_year = $exploded_slash_array[1];
		//now call our function
		$num_spotless_days = getNumSpotlessDays($my_month, $my_year);

		//now call our function
		$smoothed_sunspot_number = getSmoothedSpotsPerMonth($my_month, $my_year);
			
		//add it to the chart
		$chart['chart_data'][1][$my_index] = $smoothed_sunspot_number;
	}

	//make this a line chart
	$chart['chart_type'] = 'line';
}
////////////////////////////////////////////



////////////////////////////////////////////
//if they sent a command to view only spotless days
else if($view_sunspotnumbers_checkbox != 'yes' && $view_spotlessdays_checkbox == 'yes'){

	//here's the titles of the chart
	$chart['chart_data'][1][0] = 'Anti-sunspot number';
	
	//loop through the array and add all the elements to the chart
	for($i=0; $i<$my_count; $i++){
	
		//we have to add one to the index since our
		//zero index is the title of the chart
		$my_index = ($i + 1);
		
		//get a modulus so we can display every tenth tick on the axis
		$my_modulo = ($i % $my_divisor);
	
		//if this is the first or last result or a multiple of ten
		//then add this month and year to the axis
		//otherwise all the years will crowd up and become a mess
		//ACTUALLY WE'LL SHOW 11 DATE TICKS
		//10 IS MUCH HARDER TO CALCULATE SINCE ZERO ELEMENT 
		//ALSO RESULTS IN A MODULUS OF ZERO
		if(($my_modulo == 0 || $i == 0 || $i == $count_minus_one) && $month_years_array[$i] > 0){
			$chart['chart_data'][0][$my_index] = $month_years_array[$i];
		}
	
		//else just use an empty string
		else{
			$chart['chart_data'][0][$my_index] = '';
		}
		
		//add the number of spotless days using our function
		//first we have to split the month and year on the leading slash
		$exploded_slash_array = explode('/', $month_years_array[$i]);
		$my_month = $exploded_slash_array[0];
		$my_year = $exploded_slash_array[1];
		//now call our function
		$num_spotless_days = getNumSpotlessDays($my_month, $my_year);
		
		//add it to the chart
		$chart['chart_data'][1][$my_index] = $num_spotless_days;
	}
}
////////////////////////////////////////////



////////////////////////////////////////////
//if they sent a command to view both sunspot numbers and spotless days
else if($view_sunspotnumbers_checkbox == 'yes' && $view_spotlessdays_checkbox == 'yes'){

	//here's the titles of the chart
	$chart['chart_data'][1][0] = 'Anti-sunspot number';
	$chart['chart_data'][2][0] = 'Sunspot number';
	
	//loop through the array and add all the elements to the chart
	for($i=0; $i<$my_count; $i++){
	
		//we have to add one to the index since our
		//zero index is the title of the chart
		$my_index = ($i + 1);
		
		//get a modulus so we can display every tenth tick on the axis
		$my_modulo = ($i % $my_divisor);
	
		//if this is the first or last result or a multiple of ten
		//then add this month and year to the axis
		//otherwise all the years will crowd up and become a mess
		//ACTUALLY WE'LL SHOW 11 DATE TICKS
		//10 IS MUCH HARDER TO CALCULATE SINCE ZERO ELEMENT 
		//ALSO RESULTS IN A MODULUS OF ZERO
		if(($my_modulo == 0 || $i == 0 || $i == $count_minus_one) && $month_years_array[$i] > 0){
			$chart['chart_data'][0][$my_index] = $month_years_array[$i];
		}
	
		//else just use an empty string
		else{
			$chart['chart_data'][0][$my_index] = '';
		}
		
		//add the number of spotless days using our function
		//first we have to split the month and year on the leading slash
		$exploded_slash_array = explode('/', $month_years_array[$i]);
		$my_month = $exploded_slash_array[0];
		$my_year = $exploded_slash_array[1];
		//now call our function
		$num_spotless_days = getNumSpotlessDays($my_month, $my_year);
		
		//add it to the chart
		//$chart['chart_data'][1][$my_index] = $num_spotless_days;
		$chart['chart_data'][1][$my_index] = asPercentage($num_spotless_days, 0, 40);


		/////////////////////
		//now call our function
		$smoothed_sunspot_number = getSmoothedSpotsPerMonth($my_month, $my_year);
			
		//add it to the chart
		//$chart['chart_data'][2][$my_index] = $smoothed_sunspot_number;
		$chart['chart_data'][2][$my_index] = asPercentage($smoothed_sunspot_number, 0, 200);
			
		//tell the chart to use bars for the spotless days 
		//and a line for the monthly smoothed number
		//this gets defined multiple times but that doesn't hurt anything
		$chart['chart_type'] = array ('column', 'line');
		/////////////////////
	}


		/////////////////////
		//add some numbers to the right side of the chart
		$chart [ 'draw' ][ 0 ] = array ( 'type'=>"text", 'x'=>627, 'y'=>355, 'text'=>'0', 'color'=>"000000" );
		$chart [ 'draw' ][ 1 ] = array ( 'type'=>"text", 'x'=>627, 'y'=>285, 'text'=>'50', 'color'=>"000000" );
		$chart [ 'draw' ][ 2 ] = array ( 'type'=>"text", 'x'=>627, 'y'=>215, 'text'=>'100', 'color'=>"000000" );
		$chart [ 'draw' ][ 3 ] = array ( 'type'=>"text", 'x'=>627, 'y'=>145, 'text'=>'150', 'color'=>"000000" );
		$chart [ 'draw' ][ 4 ] = array ( 'type'=>"text", 'x'=>627, 'y'=>75, 'text'=>'200', 'color'=>"000000" );
		/////////////////////

		/////////////////////
		//override the text in the value-axis
		$chart [ 'axis_value_text' ] = array ('0', '10', '20', '30', '40');
		/////////////////////
	
}
////////////////////////////////////////////


//set the font size smaller than normal
$chart ['axis_category']['size'] = 12;

//send the new data to charts.swf
SendChartData ( $chart );

?>