<?php

//this is generate_testchart.php
//by joshua kitchener <staff@dot-comet.com>
//THERE CAN BE NO OUTPUTTING IN THIS SCRIPT!!
//IT WILL CAUSE THE SCRIPT TO FAIL SILENTLY

//include the functions file
require_once('sunspot_data_functions.php');

//include charts.php to access the SendChartData function
require_once('charts.php');


//use our functions to generate to default dates
$start_date_assoc = getValidStartDate();
$end_date_assoc = getLastRecordDate();

/*
/////////////////////////////////////////////
//we'll set some defaults in case no values were sent
if(!$start_month){
	$start_date_assoc['Month'];
}

if(!$end_month){
	$end_date_assoc['Month'];
}


if(!$start_year){
	$start_date_assoc['Year'];
}

if(!$end_year){
	$end_date_assoc['Year'];
}

//we'll show both datums by default
if(!$view_sunspotnumbers_checkbox){ $view_sunspotnumbers_checkbox = 'yes'; }
if(!$view_spotlessdays_checkbox){ $view_spotlessdays_checkbox = 'yes'; }
/////////////////////////////////////////////
*/

//this null element is critical to the flash chart
$chart['chart_data'][0][0] = "";

//call our function to return an array
//of all month/years in the span
$month_years_array = getMonthYearsArray($start_month, $start_year, $end_month, $end_year);

//get the size of the array
$my_count = count($month_years_array);

//we'll just assign the count minus one
//to a convenient reference var so we can use it later
$count_minus_one = ($my_count - 1);

//we want to display a date on every 1/10th value on the axis
//so we'll divide our total number of results by twenty
$my_divisor = ($my_count / 5);
//round it off
$my_divisor = round($my_divisor);



////////////////////////////////////////////
//here's the titles of the chart
$chart['chart_data'][1][0] = 'Anti-sunspot number';
$chart['chart_data'][2][0] = '';
	
//loop through the array and add all the elements to the chart
for($i=0; $i<$my_count; $i++){
	
	//we have to add one to the index since our
	//zero index is the title of the chart
	$my_index = ($i + 1);
		
	//get a modulus so we can display every tenth tick on the axis
	$my_modulo = ($i % $my_divisor);
	
	//call our fucntion to determine if this should be added to the axis
	if(shouldBeAdded($month_years_array, $my_modulo, $i)){

		//split the date for Tony and show only the year
		$exploded_slash_array = explode('/', $month_years_array[$i]);

		//add the year to the axis
		$chart['chart_data'][0][$my_index] = $exploded_slash_array[1];
	}

	
	//else just use an empty string
	else{
		$chart['chart_data'][0][$my_index] = '';
	}
		
	//add the number of spotless days using our function
	//first we have to split the month and year on the leading slash
	$exploded_slash_array = explode('/', $month_years_array[$i]);
	$my_month = $exploded_slash_array[0];
	$my_year = $exploded_slash_array[1];
	//now call our function
	$num_spotless_days = getNumSpotlessDays($my_month, $my_year);
		
	//add it to the chart
	$chart['chart_data'][1][$my_index] = $num_spotless_days;


	/////////////////////
	//call our function to get the sunspot number info
	$averaged_sunspot_number = getAveragedSpotsPerMonth($my_month, $my_year);

	//DIVIDE IT BY SIX PER TONY'S REQUEST
	$averaged_sunspot_number = ($averaged_sunspot_number / 7);
			
	//add it to the chart
	$chart['chart_data'][2][$my_index] = $averaged_sunspot_number;
	/////////////////////
}
////////////////////////////////////////////

//set the font size, etc.
$chart [ 'axis_category' ] = array ( 'min' =>  10, 'max' => 30, 'steps' => 3, 'size' => 17);

//set the max value to 31
$chart [ 'axis_value' ] = array ( 'min' =>  10, 'max' => 30, 'steps' => 3);

//override the axis labels completely
$chart [ 'axis_value_text' ] = array ( 0, 10, 20, 30, '', '', ''); 

//set the series color yellow for the
//spotless days and light gray for the sunspot number
//which will hide the square in the legend background
$chart [ 'series_color' ] = array ( 'FF9900', '939393' ); 

//send the new data to charts.swf
SendChartData ( $chart );

?>