<?php

//this is research/index.php

//include the functions file
require_once('sunspot_data_functions.php');

//include charts.php to access the SendChartData function
require_once('charts.php');


//var_dump($_POST);
//echo "<br><br>";


//if they are submitting
if($_POST['Submit']){

	//make sure we received all required vars
	if($start_month == '.' || $start_year == '.' || $end_month == '.' || $end_year == '.'){
		$error_message = 'Error: please provide all required info.';
	}

	/*
	//make sure they sent a valid month, year, and range
	else if(!isValidMonth($start_month) || !isValidMonth($end_month)){
		$error_message = 'Error: that is not a valid month.';
	}
	*/

	else if(!isValidYear($start_year) || !isValidYear($end_year)){
		$error_message = 'Error: that is not a valid year.';
	}
	
	//make sure their end date is later than the start date
	else if(!validateTimeSpan($start_month, $start_year, $end_month, $end_year)){
		$error_message = 'Error: your start date must be prior to your end date.';
	}
	
	//make sure they didn't enter an end date which is in the future
	//and thus not in the database
	else if(!validateEndDate($end_month, $end_year)){
		$error_message = 'Error: your end date is too far in the future.';
	}
	
	//make sure they didn't select a date span of 
	//more than 75 years, which seems to cause a timeout error with the chart
	else if(!validateTimeoutSpan($start_year, $end_year)){
		$error_message = 'Error: your date span must be 75 years or less.';
	}


	//else it was all good so proceed
	else{
	
		echo 'processing chart...<br>';
		
		//call our function select all the records from this 
		//date span into an assoc array of IDs and SunspotNumbers
		$ids_spots_assoc = getIDsSpotsAssoc($start_month, $start_year, $end_month, $end_year);
		
		//call our function to return the top five continuous
		//dates with SunspotNumber of zero in an array
		$continuous_spotdates_assoc = returnContinuousSpotDatesAssoc($ids_spots_assoc);
	}
}




/////////////////////////////////////////////
//we'll set some defaults in case no values were sent
$start_date_assoc = getValidStartDate();
$end_date_assoc = getLastRecordDate();

if(!$start_month){ $start_month = $start_date_assoc['Month']; }

if(!$end_month){ $end_month = $end_date_assoc['Month']; }


if(!$start_year){ $start_year = $start_date_assoc['Year']; }

if(!$end_year){ $end_year = $end_date_assoc['Year']; }

//we'll show both datums by default
if(count($_POST) < 1 && !$view_sunspotnumbers_checkbox){ $view_sunspotnumbers_checkbox = 'yes'; }
if(count($_POST) < 1 && !$view_spotlessdays_checkbox){ $view_spotlessdays_checkbox = 'yes'; }
/////////////////////////////////////////////


//$smoothed_sunspot_number = getSmoothedSpotsPerMonth($end_month, $end_year);
//echo "smoothed_sunspot_number is $smoothed_sunspot_number<br>";

?>
<html>
<head>
<title><?php echo $site_name; ?></title>
<meta http-equiv="Content-Type" content="text/html;">
<!-- Fireworks MX Dreamweaver MX target.  Created Thu Oct 25 22:38:32 GMT-0400 2007-->
<link rel="stylesheet" href="plotter_gallery_styles.css" type="text/css">
</head>
<body bgcolor="#ffffff" link="#2B2B82" vlink="#2B2B82" topmargin="7" marginheight="7">
<div align="center">
  <table width="751" border="0" cellspacing="0" cellpadding="0" height="800">
    <tr>
      <td valign="top"> <table border="0" cellpadding="0" cellspacing="0" width="751">
          <!-- fwtable fwsrc="plot_nu_header2.png" fwbase="plot_nu_header_slcntxt.jpg" fwstyle="Dreamweaver" fwdocid = "742308039" fwnested="0" -->
          <tr> 
            <td><img src="images/spacer.gif" width="43" height="1" border="0" alt=""></td>
            <td><img src="images/spacer.gif" width="402" height="1" border="0" alt=""></td>
            <td><img src="images/spacer.gif" width="306" height="1" border="0" alt=""></td>
            <td><img src="images/spacer.gif" width="1" height="1" border="0" alt=""></td>
          </tr>
          <tr> 
            <td colspan="3"><img name="plot_nu_header_s_r1_c1" src="images/plot_nu_header_s_r1_c1.jpg" width="751" height="40" border="0" alt=""></td>
            <td><img src="images/spacer.gif" width="1" height="40" border="0" alt=""></td>
          </tr>
          <tr> 
            <td rowspan="2" colspan="2"><img name="plot_nu_header_s_r2_c1" src="images/plot_nu_header_s_r2_c1.jpg" width="445" height="166" border="0" alt=""></td>
            <td background="images/plot_nu_header_s_r2_c3.jpg"><table width="100%" border="0" cellspacing="0" cellpadding="0">
                <tr> 
                  <td width="17%"> <div align="center"><img src="icons/refractor_icon.gif" width="50" height="50"></div></td>
                  <td width="83%" class="upperRightlinksText"><a href="../ccount.php?linkURL=http://www.meade.com/">need 
                    a telescope?</a></td>
                </tr>
              </table>
              <table width="100%" border="0" cellspacing="0" cellpadding="0">
                <tr> 
                  <td><img src="images/spacer.gif" width="1" height="1"></td>
                </tr>
              </table>
              <table width="100%" border="0" cellspacing="0" cellpadding="0">
                <tr> 
                  <td width="17%"> <div align="center"><img src="icons/radio_dish_icon.gif" width="50" height="50"></div></td>
                  <td width="83%" class="upperRightlinksText"><a href="http://spaceweather.com/submissions/index.php">submit 
                    your images</a></td>
                </tr>
              </table>
              <table width="100%" border="0" cellspacing="0" cellpadding="0">
                <tr> 
                  <td><img src="images/spacer.gif" width="1" height="1"></td>
                </tr>
              </table>
              <table width="100%" border="0" cellspacing="0" cellpadding="0">
                <tr> 
                  <td width="17%"> <div align="center"><img src="icons/sun_icon.gif" width="50" height="50"></div></td>
                  <td width="83%" class="upperRightlinksText"><a href="http://spaceweather.com">back 
                    to Spaceweather.com</a></td>
                </tr>
              </table></td>
            <td><img src="images/spacer.gif" width="1" height="162" border="0" alt=""></td>
          </tr>
          <tr> 
            <td><img name="plot_nu_header_s_r3_c3" src="images/plot_nu_header_s_r3_c3.jpg" width="306" height="4" border="0" alt=""></td>
            <td><img src="images/spacer.gif" width="1" height="4" border="0" alt=""></td>
          </tr>
          <tr> 
            <td><img name="plot_nu_header_s_r4_c1" src="images/plot_nu_header_s_r4_c1.jpg" width="43" height="24" border="0" alt=""></td>
            <td colspan="2"><img name="plot_nu_header_s_r4_c2" src="images/plot_nu_header_s_r4_c2.jpg" width="708" height="24" border="0" alt=""></td>
            <td><img src="images/spacer.gif" width="1" height="24" border="0" alt=""></td>
          </tr>
        </table>
        <table width="751" border="0" cellspacing="0" cellpadding="0">
          <tr> 
            <td><img src="images/spacer.gif" width="10" height="9"></td>
          </tr>
        </table>
        <table width="751" border="0" cellspacing="0" cellpadding="0">
          <tr> 
            <td width="43">&nbsp;</td>
            <td width="708" class="summaryText"><font color="#004C99"><b><font color="#006699"><a href="http://www.spaceweather.com/glossary/sunspotnumber.html"><font color="#006699">Sunspot 
              numbers</font></a> are useful when solar activity is high</font></b></font>, 
              but to track low solar activity we need something different: the 
              anti-sunspot number. The anti-sunspot number is simply the number 
              of days in a month when the Earth-facing side of the sun has no 
              sunspots. Anti-sunspot numbers are low around Solar Max and high 
              around Solar Min. Using the tool below, you can plot monthly sunspot 
              numbers and anti-sunspot numbers for any range of dates extending 
              back to 1749. Adding up the anti-sunspot numbers for a range of 
              dates tells you how many days in that span the sun was blank. (Note: 
              Sunspot numbers come in two varieties: the Boulder sunspot number 
              and the International sunspot number. This tool uses International 
              sunspot numbers archived by the Solar Influences <a href="http://sidc.oma.be/index.php3"><font color="#006699">Data 
              Analysis Center</font></a> in Belgium.</td>
          </tr>
        </table>
        <table width="751" border="0" cellspacing="0" cellpadding="0">
          <tr> 
            <td><img src="images/spacer.gif" width="10" height="9"></td>
          </tr>
        </table>
		<table width="751" border="0" cellspacing="0" cellpadding="0">
          <tr> 
            <td width="43">&nbsp;</td>
            <td width="708"> 
              <?php
			
			//if there was an error message then display it
			if($error_message){
			
				echo "<span class='errorMessageText'>$error_message</span> 
              <table width='100%' border='0' cellspacing='0' cellpadding='0'>
                <tr> 
                  <td><img src='images/spacer.gif' width='10' height='9'></td>
                </tr>
              </table>";
			}
			
			?>
              <?php
			
			//if there was an admin message then display it
			if($admin_message){
			
				echo "<span class='errorMessageText'>$admin_message</span> 
              <table width='100%' border='0' cellspacing='0' cellpadding='0'>
                <tr> 
                  <td><img src='images/spacer.gif' width='10' height='9'></td>
                </tr>
              </table>";
			}
			
			?>
              <form name="form1" method="post" action="">
                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                  <tr> 
                    <td width="30%"> 
                      <select name="start_month" class="dropMenus">
                        <?php
						
						//this is the same concept as the days menu but
						//uses the global all_months_array defined in the functions file
						if(!$_POST['start_month']){

							//use our functions to get an assoc array with the month and year
							$first_record_assoc = getValidStartDate();
							//get the elements
							$first_month = $first_record_assoc['Month'];
							$first_year = $first_record_assoc['Year'];

							foreach(range(1, 12) as $my_var){
							
								//use our function to get the name of this month
								$month_name = getMonthNameFromNum($my_var);
							
								if($my_val == $first_month){
									echo "<option value='$my_var' selected>$month_name</option>";
								}
							
							
								else{
									echo "<option value='$my_var'>$month_name</option>";	
								}
							
							}
						}
	
						
						
						
						//else they did _POST a month (and perhaps there was an error message)
						//so we'll use that as the preselected option
						else{
						
							foreach(range(1, 12) as $my_var){
							
								//use our function to get the name of this month
								$month_name = getMonthNameFromNum($my_var);
							
								if($my_var == $_POST['start_month']){
									echo "<option value='$my_var' selected>$month_name</option>";
								}
								
								
								else{
									echo "<option value='$my_var'>$month_name</option>";	
								}
							
							}
						}
						

						
						?>
                      </select>
                      <select name="start_year" class="dropMenus">
                        <?php
						
						

						//this is the same concept as the days menu but
						//uses the global all_months_array defined in the functions file
						if(!$_POST['start_year']){

							foreach(range(1749, 2008) as $my_var){
							
								if($my_var == $first_year){
									echo "<option value='$my_var' selected>$my_var</option>";
								}
							
							
								else{
									echo "<option value='$my_var'>$my_var</option>";	
								}
							
							}
						}
	
						
						
						
						//else they did _POST a year (and perhaps there was an error message)
						//so we'll use that as the preselected option
						else{
						
							foreach(range(1749, 2008) as $my_var){
							
								if($my_var == $_POST['start_year']){
									echo "<option value='$my_var' selected>$my_var</option>";
								}
								
								
								else{
									echo "<option value='$my_var'>$my_var</option>";	
								}
							
							}
						}
						

						
						?>
                      </select>
                      <span class="adminSubtitleText"></span> 
                      <table width="100%" border="0" cellspacing="0" cellpadding="0">
                        <tr> 
                          <td><img src="images/spacer.gif" width="10" height="3"></td>
                        </tr>
                      </table>
                      <select name="end_month" class="dropMenus">
                        <?php
						
						//this is the same concept as the days menu but
						//uses the global all_months_array defined in the functions file
						if(!$_POST['end_month']){

							//use our functions to get an assoc array with the
							//month and year of the first date in the database
							$last_record_assoc = getLastRecordDate();
							//get the elements
							$last_month = $last_record_assoc['Month'];
							$last_year = $last_record_assoc['Year'];

							foreach(range(1, 12) as $my_var){
							
								//use our function to get the name of this month
								$month_name = getMonthNameFromNum($my_var);
							
								if($my_var == $last_month){
									echo "<option value='$my_var' selected>$month_name</option>";
								}
							
							
								else{
									echo "<option value='$my_var'>$month_name</option>";	
								}
							
							}
						}
	
						
						
						
						//else they did _POST a month (and perhaps there was an error message)
						//so we'll use that as the preselected option
						else{
						
							foreach(range(1, 12) as $my_var){
							
								//use our function to get the name of this month
								$month_name = getMonthNameFromNum($my_var);
							
								if($my_var == $_POST['end_month']){
									echo "<option value='$my_var' selected>$month_name</option>";
								}
								
								
								else{
									echo "<option value='$my_var'>$month_name</option>";	
								}
							
							}
						}
						

						
						?>
                      </select>
                      <select name="end_year" class="dropMenus">
                        <?php
						
						

						//this is the same concept as the days menu but
						//uses the global all_months_array defined in the functions file
						if(!$_POST['end_year']){

							foreach(range(1749, 2008) as $my_var){
							
								if($my_var == $last_year){
									echo "<option value='$my_var' selected>$my_var</option>";
								}
							
							
								else{
									echo "<option value='$my_var'>$my_var</option>";	
								}
							
							}
						}
	
						
						
						
						//else they did _POST a year (and perhaps there was an error message)
						//so we'll use that as the preselected option
						else{
						
							foreach(range(1749, 2008) as $my_var){
							
								if($my_var == $_POST['end_year']){
									echo "<option value='$my_var' selected>$my_var</option>";
								}
								
								
								else{
									echo "<option value='$my_var'>$my_var</option>";	
								}
							
							}
						}
						

						
						?>
                      </select>
                    </td>
                    <td width="70%" valign="bottom"> 
                      <input type="submit" name="Submit" value="Submit">
                    </td>
                  </tr>
                </table>
                <span class="adminSubtitleText"></span> 
                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                  <tr> 
                    <td><img src="images/spacer.gif" width="10" height="5"></td>
                  </tr>
                </table>
                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                  <tr> 
                    <td><img src="images/spacer.gif" width="10" height="10"></td>
                  </tr>
                </table>
                <!--
				<table width="100%" border="0" cellspacing="0" cellpadding="0">
                  <tr>
                    <td width="4%"><img src="images/num_spotlessdays_verttitle.jpg" width="48" height="402"></td>
                    <td width="96%"><img src="images/chart_placeholder.gif" width="644" height="402"></td>
                  </tr>
                </table>
				-->
				<table width="100%" border="0" cellspacing="0" cellpadding="0">
                  <tr> 
                    <td><img src="images/spacer.gif" width="10" height="10"></td>
                  </tr>
                </table>
                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                  <tr> 
                    <td> 
                      <?php
			
			//we'll only show the chart if there were no errors
			//the timeout parameter should ensure the flash chart doesn't timeout
			if(!$error_message){
			
				echo "<table width='100%' border='0' cellspacing='0' cellpadding='0'>
                  <tr>
                    <td width='4%'><img src='images/num_spotlessdays_verttitle.jpg' width='48' height='402'></td>
                    <td width='96%'>";
					
				echo InsertChart ( "charts.swf?timeout=9999", "charts_library", "generate_chart.php?start_month=$start_month&start_year=$start_year&end_month=$end_month&end_year=$end_year&view_sunspotnumbers_checkbox=$view_sunspotnumbers_checkbox&view_spotlessdays_checkbox=$view_spotlessdays_checkbox", 644, 402 );
					
				echo "</td>
                  </tr>
                </table>";   
			}
			
			?>
                    </td>
                  </tr>
                </table>
                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                  <tr> 
                    <td><img src="images/spacer.gif" width="10" height="10"></td>
                  </tr>
                </table>
                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                  <tr> 
                    <td class="standardText"> 
                      <?php
			  
			  ///IF THEY'VE SUBMITTED
			  //call our function to get the total number
			  //of spotless days for this datespan
			  if($_POST['Submit']){
				  
				  $sum_spotless_days = calculateAllSpotlessDays($start_month, $start_year, $end_month, $end_year);
				  
				  //display the sum of spotless days in red
				  echo "Total days with no sunspots in date span: <font color='red'>$sum_spotless_days</font>";
			  }
			  
			  ?>
                    </td>
                  </tr>
                </table>
                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                  <tr> 
                    <td><img src="images/spacer.gif" width="10" height="10"></td>
                  </tr>
                </table>
                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                  <tr> 
                    <td class="standardText"> 
                      <?php
			  
			  ///IF THEY'VE SUBMITTED
			  //display the top five elements from our assoc array
			  //of dates and number of spotless days
			  if($_POST['Submit']){
			  
			  		echo 'Longest continuous spotless spans:<br>';
			  
			  		//initialize a counter
					$i = 0;
				
					foreach($continuous_spotdates_assoc as $my_key => $my_val){
					
						if($i < 5){
						
							echo "$my_val spotless days starting " . getDateFromRecordID($my_key) . '<br>';
						}
						
						//increment the counter
						$i++;
					}
				  
				}
			  
			  ?>
                    </td>
                  </tr>
                </table>
              </form>
            </td>
          </tr>
        </table>
        
      </td>
    </tr>
  </table>
</div>
</body>
</html>
