<?php

///////////////////////////////////////
//this is insert_smoothedsunspot_data.php
//by joshua kitchener <staff@dot-comet.com>
//this script loops through dayssn_import.dat
//splits each line into an array
//and inserts the values into a database table
///////////////////////////////////////

//include the functions file
require_once('sunspot_data_functions.php');

//the name of the textfile
$textfile = 'http://sidc.oma.be/DATA/monthssn.dat';


//MAIN

//since this script may run regularly
//we will empty the table before executing

//open the file for reading
$fp = fopen($textfile, 'r');

//if we couldn't open the table then' we'll bail out
if(!$fp){
	echo 'Error: could not open file for reading.';
	exit;
}


//if we got here then it was all good so
//we can empty the table and repopulate it
emptyMonthlySmoothedTable();

//loop through the file and insert the data into the database
while(!feof($fp)){

	$line = fgets($fp);

	//explode this line into an array so we
	//can easily access the values
	$whitespace_array = preg_split('/\s+/', $line);
	//var_dump($whitespace_array);
	
	//assign reference vars to the values
	$year_and_month = $whitespace_array[0];
	$decimal_date = $whitespace_array[1];
	$sunspot_number = $whitespace_array[2];
	$smoothed_sunspot_number = $whitespace_array[3];

	//now we'll grab the year and month
	$year = substr($year_and_month, 0, 4);
	$month = substr($year_and_month, 4);

	//here's our query to insert these values in the database
	$query = "insert into MONTHLY_SMOOTHED (Year, Month, DecimalDate, SunspotNumber, SmoothedSunspotNumber , DateCreated) values ('$year', '$month', '$decimal_date', '$sunspot_number', '$smoothed_sunspot_number', '$the_date')";
	echo "$query<br>";
	$results = mysql_query($query);
	//check for general error
	if(!$results){
		$error_message = "I'm sorry, there was a database insert error. 297";
		errorHandler($error_message);
	}
}



//close the textfile
fclose($fp);

echo 'done!';

?>
