<?php

///////////////////////////////////////
//this is insert_sunspot_data.php
//by joshua kitchener <staff@dot-comet.com>
//this script loops through dayssn_import.dat
//splits each line into an array
//and inserts the values into a database table
///////////////////////////////////////

//include the functions file
require_once('sunspot_data_functions.php');

//the name of the textfile
$textfile = 'http://sidc.oma.be/DATA/dayssn_import.dat';


//MAIN

//open the file for reading
$fp = fopen($textfile, 'r');

//if we couldn't open the table then' we'll bail out
if(!$fp){
	echo 'Error: could not open file for reading.';
	exit;
}

//We need our db connector that's created in the include file

global $db;

//if we got here then it was all good so
//we can empty the table and repopulate it
emptySunpotRecordsTable();

//loop through the file and insert the data into the database
while(!feof($fp)){

	$line = fgets($fp);

	//explode this line into an array so we
	//can easily access the values
	$whitespace_array = preg_split('/\s+/', $line);
	//var_dump($whitespace_array);
	
	//assign reference vars to the values
	$year = $whitespace_array[0];
	$month = $whitespace_array[1];
	$day = $whitespace_array[2];
	$decimal_date = $whitespace_array[3];
	$sunspot_number = $whitespace_array[4];

	//here's our query to insert these values in the database
	$query = "insert into SUNSPOT_RECORDS (Year, Month, Day, DecimalDate, SunspotNumber, DateCreated) values ('$year', '$month', '$day', '$decimal_date', '$sunspot_number', '$the_date')";
	echo "$query<br>";
	$results = mysqli_query($db,$query);
	//check for general error
	if(!$results){
		$error_message = "I'm sorry, there was a database insert error. 297";
		errorHandler($error_message);
	}
}



//close the textfile
fclose($fp);

echo 'done!';

?>
