<?php

//this is spotless_days.php

//include the functions file
require_once('sunspot_data_functions.php');

//include charts.php to access the SendChartData function
require_once('charts.php');

var_dump($_POST);
echo "<br><br>";

$start_date_assoc = getValidStartDate();
var_dump($start_date_assoc);
echo "<br><br>";

$end_date_assoc = getLastRecordDate();
var_dump($end_date_assoc);
echo "<br><br>";


//if they are submitting
if($_POST['Submit']){

	//make sure we received all required vars
	if($start_month == '.' || $start_year == '.' || $end_month == '.' || $end_year == '.'){
		$error_message = 'Error: please provide all required info.';
	}
	
	//make sure they checked at least one checkbox
	else if($view_sunspotnumbers_checkbox != 'yes' && $view_spotlessdays_checkbox != 'yes'){
		$error_message = 'Error: please select at least one checkbox.';
	}

	/*
	//make sure they sent a valid month, year, and range
	else if(!isValidMonth($start_month) || !isValidMonth($end_month)){
		$error_message = 'Error: that is not a valid month.';
	}
	*/

	else if(!isValidYear($start_year) || !isValidYear($end_year)){
		$error_message = 'Error: that is not a valid year.';
	}
	
	//make sure their end date is later than the start date
	else if(!validateTimeSpan($start_month, $start_year, $end_month, $end_year)){
		$error_message = 'Error: your start date must be prior to your end date.';
	}
	
	//make sure they didn't enter an end date which is in the future
	//and thus not in the database
	else if(!validateEndDate($end_month, $end_year)){
		$error_message = 'Error: your end date is too far in the future.';
	}
	
	//make sure they didn't select a date span of 
	//more than 75 years, which seems to cause a timeout error with the chart
	else if(!validateTimeoutSpan($start_year, $end_year)){
		$error_message = 'Error: your date span must be 75 years or less.';
	}


	//else it was all good so proceed
	else{
	
		echo 'processing chart...<br>';
		
		//call our function select all the records from this 
		//date span into an assoc array of IDs and SunspotNumbers
		$ids_spots_assoc = getIDsSpotsAssoc($start_month, $start_year, $end_month, $end_year);
		
		//call our function to return the top five continuous
		//dates with SunspotNumber of zero in an array
		$continuous_spotdates_assoc = returnContinuousSpotDatesAssoc($ids_spots_assoc);
	}
}




/////////////////////////////////////////////
//we'll set some defaults in case no values were sent
if(!$start_month){ $start_month = $start_date_assoc['Month']; }

if(!$end_month){ $end_month = $end_date_assoc['Month']; }


if(!$start_year){ $start_year = $start_date_assoc['Year']; }

if(!$end_year){ $end_year = $end_date_assoc['Year']; }

//we'll show both datums by default
if(!_POST && !$view_sunspotnumbers_checkbox){ $view_sunspotnumbers_checkbox = 'yes'; }
if(!_POST && !$view_spotlessdays_checkbox){ $view_spotlessdays_checkbox = 'yes'; }
/////////////////////////////////////////////

?>
<html>
<head>
<title><?php echo $site_name; ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link rel="stylesheet" href="sunspot_charts_styles.css" type="text/css">
</head>

<body bgcolor="#FFFFFF" text="#000000">
<table width="100%" border="0" cellspacing="0" cellpadding="0" height="100%">
  <tr>
    <td>
      <div align="center"> 
        <form name="form1" method="post" action="<?php echo $PHP_SELF; ?>">
          <?php
		  
		  //if there was an error then display it
		  if($error_message){
		  
		  		echo "<table width='650' border='0' cellspacing='0' cellpadding='0'>
					<tr> 
					  <td class='errorMessageText'>$error_message</td>
					</tr>
				  </table>
				  <table width='650' border='0' cellspacing='0' cellpadding='0'>
					<tr> 
					  <td><img src='images/spacer.gif' width='10' height='6'></td>
					</tr>
				  </table>";
		  }
		  
		  ?>
          <?php
		  
		  //if there was an admin message then display it
		  if($admin_message){
		  
		  		echo "<table width='650' border='0' cellspacing='0' cellpadding='0'>
					<tr> 
					  <td class='errorMessageText'>$admin_message</td>
					</tr>
				  </table>
				  <table width='650' border='0' cellspacing='0' cellpadding='0'>
					<tr> 
					  <td><img src='images/spacer.gif' width='10' height='6'></td>
					</tr>
				  </table>";
		  }
		  
		  ?>
          <table width="800" border="0" cellspacing="0" cellpadding="0">
            <tr> 
              <td> 
                <select name="start_month" class="dropMenus">
                  <?php
						
						//this is the same concept as the days menu but
						//uses the global all_months_array defined in the functions file
						if(!$_POST['start_month']){

							//use our functions to get an assoc array with the month and year
							$first_record_assoc = getValidStartDate();
							//get the elements
							$first_month = $first_record_assoc['Month'];
							$first_year = $first_record_assoc['Year'];

							foreach(range(1, 12) as $my_var){
							
								//use our function to get the name of this month
								$month_name = getMonthNameFromNum($my_var);
							
								if($my_val == $first_month){
									echo "<option value='$my_var' selected>$month_name</option>";
								}
							
							
								else{
									echo "<option value='$my_var'>$month_name</option>";	
								}
							
							}
						}
	
						
						
						
						//else they did _POST a month (and perhaps there was an error message)
						//so we'll use that as the preselected option
						else{
						
							foreach(range(1, 12) as $my_var){
							
								//use our function to get the name of this month
								$month_name = getMonthNameFromNum($my_var);
							
								if($my_var == $_POST['start_month']){
									echo "<option value='$my_var' selected>$month_name</option>";
								}
								
								
								else{
									echo "<option value='$my_var'>$month_name</option>";	
								}
							
							}
						}
						

						
						?>
                </select>
                <select name="start_year" class="dropMenus">
                  <?php
						
						

						//this is the same concept as the days menu but
						//uses the global all_months_array defined in the functions file
						if(!$_POST['start_year']){

							foreach(range(1749, 2007) as $my_var){
							
								if($my_var == $first_year){
									echo "<option value='$my_var' selected>$my_var</option>";
								}
							
							
								else{
									echo "<option value='$my_var'>$my_var</option>";	
								}
							
							}
						}
	
						
						
						
						//else they did _POST a year (and perhaps there was an error message)
						//so we'll use that as the preselected option
						else{
						
							foreach(range(1749, 2007) as $my_var){
							
								if($my_var == $_POST['start_year']){
									echo "<option value='$my_var' selected>$my_var</option>";
								}
								
								
								else{
									echo "<option value='$my_var'>$my_var</option>";	
								}
							
							}
						}
						

						
						?>
                </select>
                <span class="adminSubtitleText"></span>
<table width="800" border="0" cellspacing="0" cellpadding="0">
                  <tr> 
                    <td><img src="images/spacer.gif" width="10" height="3"></td>
                  </tr>
                </table>
                <select name="end_month" class="dropMenus">
                  <?php
						
						//this is the same concept as the days menu but
						//uses the global all_months_array defined in the functions file
						if(!$_POST['end_month']){

							//use our functions to get an assoc array with the
							//month and year of the first date in the database
							$last_record_assoc = getLastRecordDate();
							//get the elements
							$last_month = $last_record_assoc['Month'];
							$last_year = $last_record_assoc['Year'];

							foreach(range(1, 12) as $my_var){
							
								//use our function to get the name of this month
								$month_name = getMonthNameFromNum($my_var);
							
								if($my_var == $last_month){
									echo "<option value='$my_var' selected>$month_name</option>";
								}
							
							
								else{
									echo "<option value='$my_var'>$month_name</option>";	
								}
							
							}
						}
	
						
						
						
						//else they did _POST a month (and perhaps there was an error message)
						//so we'll use that as the preselected option
						else{
						
							foreach(range(1, 12) as $my_var){
							
								//use our function to get the name of this month
								$month_name = getMonthNameFromNum($my_var);
							
								if($my_var == $_POST['end_month']){
									echo "<option value='$my_var' selected>$month_name</option>";
								}
								
								
								else{
									echo "<option value='$my_var'>$month_name</option>";	
								}
							
							}
						}
						

						
						?>
                </select>
                <select name="end_year" class="dropMenus">
                  <?php
						
						

						//this is the same concept as the days menu but
						//uses the global all_months_array defined in the functions file
						if(!$_POST['end_year']){

							foreach(range(1749, 2007) as $my_var){
							
								if($my_var == $last_year){
									echo "<option value='$my_var' selected>$my_var</option>";
								}
							
							
								else{
									echo "<option value='$my_var'>$my_var</option>";	
								}
							
							}
						}
	
						
						
						
						//else they did _POST a year (and perhaps there was an error message)
						//so we'll use that as the preselected option
						else{
						
							foreach(range(1749, 2007) as $my_var){
							
								if($my_var == $_POST['end_year']){
									echo "<option value='$my_var' selected>$my_var</option>";
								}
								
								
								else{
									echo "<option value='$my_var'>$my_var</option>";	
								}
							
							}
						}
						

						
						?>
                </select>
                <span class="adminSubtitleText"></span>
<table width="800" border="0" cellspacing="0" cellpadding="0">
                  <tr> 
                    <td><img src="images/spacer.gif" width="10" height="5"></td>
                  </tr>
                </table>
                <table width="800" border="0" cellspacing="0" cellpadding="0">
                  <tr>
                    <td width="252"> 
                      <?php
				
				//if the checkbox was selected then show it preselected
				if($view_sunspotnumbers_checkbox == 'yes'){
					echo "<input type='checkbox' name='view_sunspotnumbers_checkbox' value='yes' checked>";
				}
				
				//else show it unselected
				else{
					echo "<input type='checkbox' name='view_sunspotnumbers_checkbox' value='yes'>";
				}
				
				?>
                      <span class="viewSunspotNumbersCheckboxText">View sunspot 
                      numbers </span></td>
                    <td width="548"> 
                      <?php
				
				//if the checkbox was selected then show it preselected
				if($view_spotlessdays_checkbox == 'yes'){
					echo "<input type='checkbox' name='view_spotlessdays_checkbox' value='yes' checked>";
				}
				
				//else show it unselected
				else{
					echo "<input type='checkbox' name='view_spotlessdays_checkbox' value='yes'>";
				}
				
				?>
                      <span class="viewSunspotNumbersCheckboxText">View spotless 
                      days </span></td>
                  </tr>
                </table>
                <table width="800" border="0" cellspacing="0" cellpadding="0">
                  <tr> 
                    <td><img src="images/spacer.gif" width="10" height="3"></td>
                  </tr>
                </table>
                <input type="submit" name="Submit" value="Submit">
              </td>
            </tr>
          </table>
          <table width="800" border="0" cellspacing="0" cellpadding="0">
            <tr> 
              <td><img src="images/spacer.gif" width="10" height="10"></td>
            </tr>
          </table>
          <table width="800" border="0" cellspacing="0" cellpadding="0">
            <tr> 
              <td>
			<?php
			
			//we'll only show the chart if there were no errors
			//the timeout parameter should ensure the flash chart doesn't timeout
			if(!$error_message){
				echo InsertChart ( "charts.swf?timeout=9999", "charts_library", "generate_chart.php?start_month=$start_month&start_year=$start_year&end_month=$end_month&end_year=$end_year&view_sunspotnumbers_checkbox=$view_sunspotnumbers_checkbox&view_spotlessdays_checkbox=$view_spotlessdays_checkbox", 800, 500 );
			}
			
			?>
			</td>
            </tr>
          </table>
        </form>
        <table width="800" border="0" cellspacing="0" cellpadding="0">
          <tr> 
            <td><img src="images/spacer.gif" width="10" height="10"></td>
          </tr>
        </table>
        <table width="800" border="0" cellspacing="0" cellpadding="0">
          <tr> 
            <td class="standardText">
              <?php
			  
			  ///IF THEY'VE SUBMITTED
			  //call our function to get the total number
			  //of spotless days for this datespan
			  if($_POST['Submit']){
				  
				  $sum_spotless_days = calculateAllSpotlessDays($start_month, $start_year, $end_month, $end_year);
				  
				  //display the sum of spotless days in red
				  echo "Total days with no sunspots in date span: <font color='red'>$sum_spotless_days</font>";
			  }
			  
			  ?>
			  </td>
          </tr>
        </table>
        <table width="800" border="0" cellspacing="0" cellpadding="0">
          <tr> 
            <td><img src="images/spacer.gif" width="10" height="10"></td>
          </tr>
        </table>
        <table width="800" border="0" cellspacing="0" cellpadding="0">
          <tr> 
            <td class="standardText"> 
              <?php
			  
			  ///IF THEY'VE SUBMITTED
			  //display the top five elements from our assoc array
			  //of dates and number of spotless days
			  if($_POST['Submit']){
			  
			  		echo 'Longest continuous spotless spans:<br>';
			  
			  		//initialize a counter
					$i = 0;
				
					foreach($continuous_spotdates_assoc as $my_key => $my_val){
					
						if($i < 5){
						
							echo "$my_val spotless days starting " . getDateFromRecordID($my_key) . '<br>';
						}
						
						//increment the counter
						$i++;
					}
				  
				}
			  
			  ?>
            </td>
          </tr>
        </table>
      </div>
    </td>
  </tr>
</table>
</body>
</html>
