<?php

/////////////////////////////////////////////
//this is sunspot_data_functions.php
//by joshua kitchener <staff@dot-comet.com>
/////////////////////////////////////////////

ini_set('session.use_trans_sid', 1);

session_cache_limiter('private_must_revalidate');
session_start();

//TURN ERROR REPORTING OFF
//error_reporting(0);

//increased error reporting
//error_reporting(E_ALL | E_STRICT);
//ini_set('display_errors', 'On');

//set the execution time to go longer than usual
//as the spotless days chart can take a long time
ini_set('max_execution_time', 600);

//var_dump($_SESSION);


//this is the general error_function
//this has to go near the top of the functions file
function errorHandler($error_message){
	//$relative_url = "error_page.php?error_message=$error_message";
	//header("Location: $relative_url");
	echo "$error_message<br>";
	exit;
}



//here's the date
$the_date = date("d m y");

//here's the current time
$the_time = time();

//all the months
$all_months_array = array('January' => '01', 'February' => '02', 'March' => '03', 'April' => '04', 'May' => '05', 'June' => '06', 'July' => '07', 'August' => '08', 'September' => '09',
	'October' => '10', 'November' => '11', 'December' => '12');

//here's all the years
//I don't think these really need quotes
$all_years_array = array('2005' => '05', '2006' => '06', '2007' => '07', '2008' => '08');


//the name of this website
$site_name = 'Sunspot Plotter';


//this is a date formatted like January 25, 2007
//which is used several times on the frontpage
$formatted_date = date("F j, Y");



///////////////////////////////////////////////////////
//we start by making a connection to our database
$db = mysql_pconnect('localhost', 'joshua', '1webdude');

if(!$db){
	$error_message = 'unable to connect to database';
	errorHandler($error_message);
}


$sel = mysql_select_db('meade_ds');
//$sel = mysql_select_db('sunspots');


if(!$sel){
	$error_message = "I'm sorry, there was a problem with the database. Please try back later.";
	errorHandler($error_message);
}
///////////////////////////////////////////////////////



//a very simple function to pad a number variable
//if that number is less than ten
//this will be used primarily for days and months
//so they match our standard date format (dd mm yy)
function pad(&$num){

	//if the number is less than ten
	//then prepend a zero
	if($num < 10){
		$num = '0' . $num;
	}


	return $num;
}



//a  very simple function which uses a reference
//to remove the leading zero from a var, if any
function unpad(&$num){

	//find the first character
	$first_char = substr($num, 0, 1);

	//if the var is a zero then remove it
	//should we use the idenity operator here?
	if($first_char == '0'){

		//remove it by overwriting the var
		$num = substr($num, 1);
	}

	return $num;

}




//function to validate a submitted day
function isValidDay($day){
	
	//make sure the day is two digits
	$my_length = strlen($day);

	if($my_length < 2){
		return false;
	}

	else{
		return true;
	}
}



//function to validate a submitted month
function isValidMonth($month){

	//make sure the month is two digits
	$my_length = strlen($month);

	if($my_length < 2){
		return false;
	}

	else{
		return true;
	}
}



//function to validate a submitted year
function isValidYear($year){

	//make sure the year is four digits
	$my_length = strlen($year);

	if($my_length < 4){
		return false;
	}

	else{
		return true;
	}
}



//function to validate a submitted range
function isValidRange($range){

	if($range < 1 || $range > 10){
		return false;
	}

	else{
		return true;
	}
}




//a wrapper function to get a decimal date
//for a year and month for smoothed monthly sunspots
function getDecimalDate($month, $year){

	//select the decimal date for this 
	//month and year from the database
	$query = "select * from MONTHLY_SMOOTHED where Month = '$month' and Year = '$year'";
	$results = mysql_query($query);
	//check for general error
	if(!$results){
		$error_message = "I'm sorry, there was a database select error. 274";
		errorHandler($error_message);
	}

	//get the values
	$row = mysql_fetch_assoc($results);

	$decimal_date = stripslashes($row['DecimalDate']);

	return $decimal_date;
}





//a wrapper function to get a decimal date
//for a year and month for the SUNSPOT_RECORDS table
function getSunspotDecimalDate($month, $year){

	//select the decimal date for this 
	//month and year from the database
	$query = "select * from SUNSPOT_RECORDS where Month = '$month' and Year = '$year'";
	$results = mysql_query($query);
	//check for general error
	if(!$results){
		$error_message = "I'm sorry, there was a database select error. 275";
		errorHandler($error_message);
	}

	//get the values
	$row = mysql_fetch_assoc($results);

	$decimal_date = stripslashes($row['DecimalDate']);

	return $decimal_date;
}




//a function to return false if a start date
//is later than an end date
function validateTimeSpan($start_month, $start_year, $end_month, $end_year){

	//add the months and years together
	//this is a clunky way of doing this but there
	//were no timestamps before 1970
	$start_sum = ($start_month + $start_year);
	//echo "start_sum is $start_sum<br>";

	$end_sum = ($end_month + $end_year);
	//echo "end_sum is $end_sum<br>";

	if($end_sum <= $start_sum){
		return false;
	}

	//if we got here we can return true
	return true;
}




//call our function to return an array
//of all month/years in the span
function getMonthYearsArray($start_month, $start_year, $end_month, $end_year){

	//declare the array we'll return our results in
	$month_years_array = array();

	//get the decimal date from SUNSPOT_RECORDS for
	//the start month and year
	$start_decimal_date = getSunspotDecimalDate($start_month, $start_year);

	//get the decimal date for the end month and year
	$end_decimal_date = getSunspotDecimalDate($end_month, $end_year);

	//now select all the months and years between the dates
	//note we are performing a distinct query here
	$query = "select distinct Month, Year from SUNSPOT_RECORDS where 
			DecimalDate >= '$start_decimal_date' and DecimalDate <= '$end_decimal_date' order by RecordID";
	//echo "$query<br>";
	$results = mysql_query($query);
	//check for general error
	if(!$results){
		$error_message = "I'm sorry, there was a database select error. 396";
		errorHandler($error_message);
	}


	//loop through and get the values
	while($row = mysql_fetch_assoc($results)){

		$my_month = stripslashes($row['Month']);
		$my_year = stripslashes($row['Year']);

		//concat the month and year into a string suited
		//to return as an array element
		$month_year_string = $my_month . '/' . $my_year;

		//add it to our array
		array_push($month_years_array, $month_year_string);
	}


	//finally, return the array
	return $month_years_array;
}




//a function to get the number of spotless days
//for the given month and year from the SUNSPOT_RECORDS table
function getNumSpotlessDays($month, $year){

	$query = "select * from SUNSPOT_RECORDS where Month = '$month' and 
			Year = '$year' and SunspotNumber = 0";
	$results = mysql_query($query);
	//check for general error
	if(!$results){
		$error_message = "I'm sorry, there was a database select error. 273";
		errorHandler($error_message);
	}

	//just get the number of results
	$num_results = mysql_num_rows($results);

	//return the number of results
	return $num_results;
}





//a function to get the number of sunspots from the 
//MONTHLY_SMOOTHED table per month and year passed as argument
function getSmoothedSpotsPerMonth($month, $year){

	$query = "select * from MONTHLY_SMOOTHED where Month = '$month' and Year = '$year'";
	//echo "$query<br><br>";
	$results = mysql_query($query);
	//check for general error
	if(!$results){
		$error_message = "I'm sorry, there was a database select error. 593";
		errorHandler($error_message);
	}

	//get the value
	$row = mysql_fetch_assoc($results);

	$smoothed_sunspot_number = stripslashes($row['SmoothedSunspotNumber']);

	return $smoothed_sunspot_number;
}





//a function to calculate all the spotless days
//within a given datespan and return an integer
function calculateAllSpotlessDays($start_month, $start_year, $end_month, $end_year){

	//initialize a variable we will use to store
	//and add to the sum of spotless days to return
	$sum_spotless_days = 0;

	//call our function to return an array of
	//all the months and years within the given datespan
	$month_years_array = getMonthYearsArray($start_month, $start_year, $end_month, $end_year);

	//loop through the array and get the
	//number of spotless days in each month/year
	foreach($month_years_array as $my_var){

		//explode on the forward slash
		$exploded_slash_array = explode('/', $my_var);
		$my_month = $exploded_slash_array[0];
		$my_year = $exploded_slash_array[1];

		//now call our function
		$num_spotless_days = getNumSpotlessDays($my_month, $my_year);
		//echo "num_spotless_days is $num_spotless_days<br>";

		//add the amount to our sum
		$sum_spotless_days += $num_spotless_days;
	}

	
	//finally, return the sum
	return $sum_spotless_days;
}





//a function to get a date in this format (d/m/yyyy) from a RecordID
function getDateFromRecordID($record_id){

	$query = "select * from SUNSPOT_RECORDS where RecordID = '$record_id'";
	$results = mysql_query($query);
	//check for general error
	if(!$results){
		$error_message = "I'm sorry, there was a database select error. 693";
		errorHandler($error_message);
	}

	//get the month and year
	$row = mysql_fetch_assoc($results);

	$day = stripslashes($row['Day']);
	$month = stripslashes($row['Month']);
	$year = stripslashes($row['Year']);

	//concat them with a leading slash in the middle
	$concatted_date = $day . '/' . $month . '/' . $year;

	//return the date
	return $concatted_date;
}





//a function to select all the records from this 
//date span into an assoc array of IDs and SunspotNumbers
function getIDsSpotsAssoc($start_month, $start_year, $end_month, $end_year){

	//declare an assoc array which we'll use
	//to store the IDs and SunspotNumbers
	$ids_spots_assoc = array();

	//get the decimal date from SUNSPOT_RECORDS for
	//the start month and year
	$start_decimal_date = getSunspotDecimalDate($start_month, $start_year);

	//get the decimal date for the end month and year
	$end_decimal_date = getSunspotDecimalDate($end_month, $end_year);

	$query = "select * from SUNSPOT_RECORDS where 
			DecimalDate >= '$start_decimal_date' and DecimalDate <= '$end_decimal_date'";
	$results = mysql_query($query);
	//check for general error
	if(!$results){
		$error_message = "I'm sorry, there was a database select error. 730";
		errorHandler($error_message);
	}

	//loop through the results and add the ID and SunspotNumber
	//from each record to the assoc array
	while($row = mysql_fetch_assoc($results)){

		//get the values we need
		$record_id = stripslashes($row['RecordID']);
		$sunspot_number = stripslashes($row['SunspotNumber']);

		//add it to the assoc array
		$ids_spots_assoc[$record_id] = $sunspot_number;
	}


	//finally, return the assoc array
	return $ids_spots_assoc;
}





//a function which accepts an assoc array
//of RecordIDs and SunspotNumbers like this $ids_spots_assoc[1][12]
//where the key(1) is the RecordID and the value(12) is the SunspotNumber
//and returns an assocarray of the top five dates 
//which begin the longest continuous spans
//of uninterrupted SunspotNumbers of zero
//and their count of zero sunspot days
function returnContinuousSpotDatesAssoc($ids_spots_assoc){

	//a var which will store the recordID which
	//currently has the most continuous zero sunspots
	$current_leading_id = 0;

	//here's a var which will store the current zero count
	$zero_count = 0;

	//the assoc array which we'll use to store 
	//and finally return the top five results
	$topfive_dates_assoc = array();

	//we're going to loop though the assoc and
	//examine the value of each element
	//if its zero then we increment the zero_count
	foreach($ids_spots_assoc as $my_key => $my_val){

		//echo "my_val is $my_val<br>";

		//if the value is zero then set the
		//current_leading_id and the zero_count
		if($my_val == 0){

			$current_leading_id = $my_key;
			$zero_count += 1;
		}


		//else if it wasn't zero then add this date
		//and commensurate zero sunspot number days to the assoc array
		else{

			//only set this element if it doesn't already exist
			//in the assoc array - otherwise we'll overwrite it
			//the second condition is a hack to ensure we don't add any 
			//zero count elements to the assoc array
			if(!isset($topfive_dates_assoc[$current_leading_id]) && $zero_count != 0){

				//now to get the first ID in this sequence
				//we simply have to subtract the zero_count from the ID
				$current_leading_id -= ($zero_count - 1);

				//get the date for this ID using our function
				$leading_date = getDateFromRecordID($current_leading_id);

				////////////////////
				$topfive_dates_assoc[$current_leading_id] = $zero_count;
				////////////////////
			}

			//now we have to reinitialize the zero_count
			$zero_count = 0;
		}
	}

		
	//now we have to sort the array according 
	//to the values with the highest values first
	arsort($topfive_dates_assoc);

	//return the assoc array
	return $topfive_dates_assoc;
}





//a function to ensure a given end month and year
//are actually in the database and not too far off in the future
function validateEndDate($end_month, $end_year){

	//for now we can just check that this
	//year and month are in the database
	//and return false otherwise
	$query = "select * from SUNSPOT_RECORDS where Month = '$end_month' and Year = '$end_year'";
	//echo $query;
	$results = mysql_query($query);
	//check for general error
	if(!$results){
		$error_message = "I'm sorry, there was a database select error. 845";
		errorHandler($error_message);
	}

	//get the number of results
	$num_results = mysql_num_rows($results);

	//if there were no results then return false
	if($num_results < 1){
		return false;
	}


	//if we got here we can return true
	return true;
}





//a function to return false if the user
//has selected a date span of more than say, 75 years
//which seems to cause the flash chart to timeout
//for some strange reason
function validateTimeoutSpan($start_year, $end_year){

	//simply subtract the starting year from the ending year
	//and get the product
	$my_product = ($end_year - $start_year);

	//if its 75 years or more then return false
	if($my_product >= 75){
		return false;
	}

	//if we got here then we can return true
	return true;
}




//a function to empty the SUNSPOT_RECORDS table
function emptySunpotRecordsTable(){

	$query = "truncate table SUNSPOT_RECORDS";
	$results = mysql_query($query);
	//check for general error
	if(!$results){
		$error_message = "I'm sorry, there was a database truncate error. 386";
		errorHandler($error_message);
	}
}




//a function to empty the MONTHLY_SMOOTHED table
function emptyMonthlySmoothedTable(){

	$query = "truncate table MONTHLY_SMOOTHED";
	$results = mysql_query($query);
	//check for general error
	if(!$results){
		$error_message = "I'm sorry, there was a database truncate error. 934";
		errorHandler($error_message);
	}
}





//a function to return an asssoc array of the first 
//month and first year in the database
function getFirstRecordDate(){

	//create an assoc array we'll use to return the results
	$first_date_assoc = array();

	$query = "select * from MONTHLY_SMOOTHED where 1 order by RecordID limit 1";
	$results = mysql_query($query);
	//check for general error
	if(!$results){
		$error_message = "I'm sorry, there was a database select error. 033";
		errorHandler($error_message);
	}


	$row = mysql_fetch_assoc($results);

	//add the values to our assoc array
	$first_date_assoc['Month'] = stripslashes($row['Month']);
	$first_date_assoc['Year'] = stripslashes($row['Year']);

	//now return the assoc array
	return $first_date_assoc;
}




//a function to return an asssoc array of the last 
//month and first year in the database
///////////////////////////////////////////////////////
//REMEMBER TO DELETE ANY LAST BOGUS RECORDS!!
///////////////////////////////////////////////////////
function getLastRecordDate(){

	//create an assoc array we'll use to return the results
	$last_date_assoc = array();

	$query = "select * from MONTHLY_SMOOTHED where 1 order by RecordID desc limit 1";
	$results = mysql_query($query);
	//check for general error
	if(!$results){
		$error_message = "I'm sorry, there was a database select error. 290";
		errorHandler($error_message);
	}


	$row = mysql_fetch_assoc($results);

	//add the values to our assoc array
	$last_date_assoc['Month'] = stripslashes($row['Month']);
	$last_date_assoc['Year'] = stripslashes($row['Year']);

	//now return the assoc array
	return $last_date_assoc;
}




//a simple function to subtract 20 years from the last record date
//and return the resulting year and the same month
//we need this temporarily to prevent the app from retreiving
//too long a datespan and causing an error
function getValidStartDate(){

	//call our function to return an assoc array
	//of the most recent date in the database
	$last_date_assoc = getLastRecordDate();

	//subtract 20 from the year
	$last_date_assoc['Year'] -= 20;

	//return the assoc array
	return $last_date_assoc;
}




//a wrapper function to return the name 
//of a month from the month's number
function getMonthNameFromNum($num){

	//we have to globalize our assoc array of all the months
	global $all_months_array;

	//add a zero if necessary to the number
	pad($num);
	
	//loop through the assoc array and when we find a match return it
	foreach($all_months_array as $my_key => $my_val){

		if($my_val == $num){
			return $my_key;
		}
	}

	//if we got here then something went horribly wrong
	return false;
}





//a function to produce an averaged (as opposed to "smoothed")
//sunspot number for a given month and year
function getAveragedSpotsPerMonth($month, $year){

	//declare a var which we'll use to store a sum total
	$my_sum = 0;

	$query = "select * from SUNSPOT_RECORDS where Month = '$month' and Year = '$year'";
	//echo "$query<br><br>";
	$results = mysql_query($query);
	//check for general error
	if(!$results){
		$error_message = "I'm sorry, there was a database select error. 443";
		errorHandler($error_message);
	}

	//get the number of results
	$num_results = mysql_num_rows($results);

	//now loop through the results and add each one to the sum
	while($row = mysql_fetch_assoc($results)){

		//get the sunspot number
		$sunspot_number = stripslashes($row['SunspotNumber']);

		//add it to the sum
		$my_sum += $sunspot_number;
	}


	//now divide the sum by the number of results to get the average
	$my_average = ($my_sum / $num_results);

	//return it
	return $my_average;
}




//a function to determine if we should add a result to a chart
function shouldBeAdded($array, $modulo, $num){

	//if this array element is zero then return false
	if($array[$num] == 0){
		return false;
	}

	//get the array count
	$count = count($array);
	//set a var for one less than the count
	$count_minus_one = ($count - 1);

	//if this is the first number then return true
	if($num == 0){
		return true;
	}

	//if this is the last record but not a modulo then return true
	else if($num == $count_minus_one && $modulo != 0){
		return true;
	}

	//if this is a modulo but not the last record then reutrn true
	else if($modulo == 0 && $i != $count_minus_one){
		return true;
	}
}


?>
